Subject: Re: New issue with nncp-caller in 6.1.0

From: Sergey Matveev <[email-masked]>
Date: Mon, 1 Mar 2021 12:52:40 +0300

Greetings!

*** John Goerzen [2021-02-28 15:39]:
>First, THANKS for all the work you've been doing with NNCP. That's great!

Thank you!

>Avoiding the separate check step is a huge improvement for large transfers.

I am planning to add tree hashing (Merkle tree) to speed up partly
received files checking.

>Also, FYI, I've had some more posts at
>https://changelog.complete.org/archives/tag/nncp

I am subscribed to your blog. Yep, interesting things you write.
I have got similar, but on russian language :-).

>So on a machine I upgraded from 5.6.0 to 6.1.0, I'm now seeing this from
>nncp-call periodically:

Fixed it quickly in: http://www.git.cypherpunks.ru/?p=nncp.git;a=commitdiff;h=36953cde29afd58982caf2327d3dbe5bf5242256
Current messages are a long-time mess already. Seems that the first
thing I should do is to clean all of them and make a clear strict scheme
for each possible message. That should prevent that kind of errors when
some fields are missing.

>Incidentally I've also made some tests of NNCP over tor.  tor takes some time
>with connection establishment, and I wound up with some of those 10-second
>timeouts trying that.  But if I'd retry enough times, eventually it would
>work.

I think that configurable option for handshake timeout is easy to add.
Handshake timeouts are just hardcoded, that is not right.

If you do not need some kind of anonymity, then Yggdrasil works pretty
well with very low overhead and relatively low latencies. I have not
touched for years, but remember that liked it much. Very easy to setup
overlay network, where even NATed nodes can communicate through the
other ones. cjdns was very unstable when I connected to Hyperboria.

-- 
Sergey Matveev (http://www.stargrave.org/)
OpenPGP: CF60 E89A 5923 1E76 E263  6422 AE1A 8109 E498 57EF